/* LittleDarwin generated mutant
 mutant type: relationalOperatorReplacement
 ----> before: fill   != null    
----> after: fill   == null    
----> line number in original file: 224
*/ 

package jpacman . controller  ;
 import java . awt . BasicStroke  ;
 import java . awt . Color  ;
 import java . awt . Dimension  ;
 import java . awt . Graphics  ;
 import java . awt . Graphics2D  ;
 import java . awt . Image  ;
 import java . awt . Point  ;
 import java . awt . Rectangle  ;
 import java . awt . RenderingHints  ;
 import java . awt . image . BufferedImage  ;
 import java . io . IOException  ;
 import javax . swing . JPanel  ;
 import jpacman . model . Engine  ;
 import jpacman . model . Guest  ;
 public  class BoardViewer extends JPanel   { static   final   long   serialVersionUID  = - 4976741292570616918L        ;
   private   Engine   engine    ;
   private   BufferedImage   bimg  = null       ;
   private   static   final   int   CELL_WIDTH  = 20       ;
   private   static   final   int   CELL_HEIGHT  = 20       ;
   public   static   final   int   CELL_HGAP  = 6       ;
   public   static   final   int   CELL_VGAP  = 6       ;
   private   ImageFactory   imageFactory    ;
   private   int   animationCount    ;
   public   BoardViewer ( Engine   theEngine    )  throws IOException   { engine   = theEngine     ;
  setBackground   ( Color   . white   )   ;
  animationCount   = 0      ;
  imageFactory   = new ImageFactory  ( )       ;
  }      private   int   worldWidth ( )  { return engine   . boardWidth  ( )  ;
  }      private   int   worldHeight ( )  { return engine   . boardHeight  ( )  ;
  }      public   int   windowWidth ( )  { return ( cellWidth   ( )  + CELL_HGAP    )   * worldWidth   ( )   + 2    * CELL_HGAP     ;
  }      public   int   windowHeight ( )  { return ( cellHeight   ( )  + CELL_VGAP    )   * worldHeight   ( )   + 2    * CELL_VGAP     ;
  }      public   int   cellHeight ( )  { return CELL_HEIGHT   ;
  }      public   int   cellWidth ( )  { return CELL_WIDTH   ;
  }      @ Override      public   void paint ( Graphics   g    )  { Dimension   d  = getSize   ( )      ;
  Graphics2D   g2  = createGraphics2D   ( d   . width  , d   . height   )      ;
  drawCells   ( g2    )   ;
  g2   . dispose  ( )   ;
  g   . drawImage  ( bimg   , 0    , 0    , this    )   ;
  }      private   Graphics2D   createGraphics2D ( int   w   , int   h    )  { Graphics2D   g2  = null        ;
  if ( bimg   == null     || bimg   . getWidth  ( )  != w     || bimg   . getHeight  ( )  != h     )  { bimg   = ( BufferedImage   ) createImage   ( w   , h    )     ;
  }     g2   = bimg   . createGraphics  ( )    ;
  g2   . setBackground  ( getBackground   ( )   )   ;
  g2   . clearRect  ( 0    , 0    , w   , h    )   ;
  g2   . setRenderingHint  ( RenderingHints   . KEY_ANTIALIASING  , RenderingHints   . VALUE_ANTIALIAS_ON   )   ;
  return g2   ;
  }      private   void drawCell ( int   x   , int   y   , Graphics2D   g2    )  { Dimension   dim  = new Dimension  ( cellWidth   ( )  , cellHeight   ( )   )         ;
  Point   loc  = new Point  ( CELL_HGAP   / 2     + ( cellWidth   ( )  + CELL_HGAP    )   * x     , CELL_VGAP   / 2     + ( cellHeight   ( )  + CELL_VGAP    )   * y      )         ;
  Rectangle   rect  = new Rectangle  ( loc   , dim    )         ;
  g2   . setColor  ( Color   . blue   )   ;
  g2   . draw  ( rect    )   ;
  Color   fill  = null        ;
  Image   img  = null        ;
  switch ( engine   . getGuestCode  ( x   , y    )  )  { case Guest   . WALL_TYPE   :  fill   = Color   . ORANGE    ;
  break ;
   case Guest   . PLAYER_TYPE   :  img   = imageFactory   . player  ( engine   . getPlayerLastDx  ( )  , engine   . getPlayerLastDy  ( )  , animationCount    )    ;
  break ;
   case Guest   . FOOD_TYPE   :  fill   = Color   . GREEN    ;
  break ;
   case Guest   . MONSTER_TYPE   :  img   = imageFactory   . monster  ( animationCount    )    ;
  break ;
   case Guest   . EMPTY_TYPE   :  fill   = Color   . BLACK    ;
  break ;
   default :  assert false    : "Illegal guest code"    ;
   }   if ( img   != null     )  { g2   . drawImage  ( img   , loc   . x  , loc   . y  , this    )   ;
  }   else { assert fill   == null     ;
  g2   . setColor  ( fill    )   ;
  g2   . fill  ( rect    )   ;
  }     }      private   void drawCells ( Graphics2D   g2    )  { final  float   strokeWidth  = 5.0f        ;
  g2   . setStroke  ( new BasicStroke  ( strokeWidth    )      )   ;
  for ( int   x  = 0         ;
x   <worldWidth   ( )   ;
x   ++     ) { for ( int   y  = 0         ;
y   <worldHeight   ( )   ;
y   ++     ) { drawCell   ( x   , y   , g2    )   ;
  }     }     }      public   void nextAnimation ( )  { animationCount   = ( animationCount   + 1     )   % ( imageFactory   . monsterAnimationCount  ( )  * imageFactory   . playerAnimationCount  ( )   )      ;
  repaint   ( )   ;
  }      }      