/* LittleDarwin generated mutant
 mutant type: relationalOperatorReplacement
 ----> before: move   != null    
----> after: move   == null    
----> line number in original file: 288
*/ 

package jpacman . model  ;
 import java . util . Vector  ;
 public  class Game { private   Board   theBoard    ;
   private   Player   thePlayer    ;
   private   Vector <Monster    >   monsters    ;
   private   int   totalPoints    ;
   private   String  [ ]  theMap    ;
   public   Game ( )  { this   ( DEFAULT_WORLD_MAP    )   ;
  }      public   Game ( String  [ ]  map    )  { theMap   = map     ;
  initialize   ( )   ;
  assert invariant   ( )  ;
  }      void initialize ( )  { monsters   = new Vector <Monster    >   ( )       ;
  totalPoints   = 0      ;
  thePlayer   = null      ;
  theBoard   = null      ;
  loadWorld   ( theMap    )   ;
  assert invariant   ( )  ;
  }      public   boolean   initialized ( )  { return theBoard   != null     && thePlayer   != null      && monsters   != null      && totalPoints   >= 0      ;
  }      public   boolean   consistent ( )  { return ! ( playerDied   ( )  && playerWon   ( )   )    && thePlayer   . getPointsEaten  ( )  <= totalPoints     ;
  }      public   boolean   invariant ( )  { return initialized   ( )  && consistent   ( )   ;
  }      private   static   final   String  [ ]  DEFAULT_WORLD_MAP  = new String  [ ] { "WWWWWWWWWWWWWWWWWWWW"     , "W000M0W00000M0000F0W"     , "W0F00MW000000000000W"     , "W0000000000M000F000W"     , "W000000000000F00000W"     , "W000MM0000M00000000W"     , "W000000M00000000000W"     , "W00M00000F0000000WWW"     , "W0000000000000WWW00W"     , "W000000000000000000W"     , "W0000WW0WWW00000000W"     , "W0000W00F0W00000000W"     , "W0P00W0M00W00000000W"     , "W0000WWWWWW00000F00W"     , "W000000000000000000W"     , "W000000000000000000W"     , "W0F0000000000F00M00W"     , "W0WWWW0000000000000W"     , "W00F00WWWW000000WWWW"     , "WWWWWWWWWWWWWWWWWWWW"     }        ;
   public   Board   getBoard ( )  { return theBoard   ;
  }      private   Player   createPlayer ( )  { assert thePlayer   == null     : "Player exists already"    ;
  thePlayer   = new Player  ( )       ;
  return thePlayer   ;
  }      private   Food   createFood ( )  { Food   f  = new Food  ( )         ;
  totalPoints   += f   . getPoints  ( )    ;
  return f   ;
  }      private   Monster   createMonster ( )  { Monster   m  = new Monster  ( )         ;
  monsters   . add  ( m    )   ;
  return m   ;
  }      public   Player   getPlayer ( )  { return thePlayer   ;
  }      public   Vector <Monster    >   getMonsters ( )  { assert invariant   ( )  ;
  Vector <Monster    >   result  = new Vector <Monster    >   ( )         ;
  result   . addAll  ( monsters    )   ;
  assert result   != null     ;
  return result   ;
  }      private   void addGuestFromCode ( char   code   , int   x   , int   y    )  { assert getBoard   ( )  != null     : "Board should exist"    ;
  assert getBoard   ( )  . withinBorders  ( x   , y    )  ;
  Guest   theGuest  = null        ;
  switch ( code   )  { case Guest   . WALL_TYPE   :  theGuest   = new Wall  ( )       ;
  break ;
   case Guest   . PLAYER_TYPE   :  theGuest   = createPlayer   ( )    ;
  break ;
   case Guest   . FOOD_TYPE   :  theGuest   = createFood   ( )    ;
  break ;
   case Guest   . MONSTER_TYPE   :  theGuest   = createMonster   ( )    ;
  break ;
   case Guest   . EMPTY_TYPE   :  theGuest   = null      ;
  break ;
   default :  assert false    : "unknown cell type``"    + code    + "'' in worldmap"     ;
  break ;
   }   assert code   == Guest   . EMPTY_TYPE   ? theGuest   == null     : theGuest   != null      ;
  if ( theGuest   != null     )  { theGuest   . occupy  ( getBoard   ( )  . getCell  ( x   , y    )   )   ;
  }     assert theGuest   == null     || getBoard   ( )  . getCell  ( x   , y    )  . equals  ( theGuest   . getLocation  ( )   )   ;
  }      private   void loadWorld ( String  [ ]  map    )  { int   height  = map   . length      ;
  assert height   >0     : "at least one cell with one player required."    ;
  int   width  = map   [ 0    ]  . length  ( )      ;
  assert width   >0     : "empty rows not permitted."    ;
  assert theBoard   == null     ;
  theBoard   = new Board  ( width   , height    )       ;
  for ( int   y  = 0         ;
y   <height    ;
y   ++     ) { assert map   [ y   ]  . length  ( )  == width    : "all lines in map should be of equal length."    ;
  for ( int   x  = 0         ;
x   <width    ;
x   ++     ) { assert getBoard   ( )  . getGuest  ( x   , y    )  == null     : "only empty cells can be filled."    ;
  addGuestFromCode   ( map   [ y   ]  . charAt  ( x    )  , x   , y    )   ;
  }     }     assert invariant   ( )  ;
  }      void movePlayer ( int   dx   , int   dy    )  { assert invariant   ( )  ;
  assert ! gameOver   ( )   : "can only move when game isn't over"    ;
  Cell   targetCell  = getPlayer   ( )  . getLocation  ( )  . cellAtOffset  ( dx   , dy    )      ;
  PlayerMove   playerMove  = new PlayerMove  ( getPlayer   ( )  , targetCell    )         ;
  applyMove   ( playerMove    )   ;
  getPlayer   ( )  . setLastDirection  ( dx   , dy    )   ;
  assert invariant   ( )  ;
  }      private   void applyMove ( Move   move    )  { assert move   == null     ;
  assert invariant   ( )  ;
  assert ! gameOver   ( )   ;
  if ( move   . movePossible  ( )  )  { move   . apply  ( )   ;
  assert move   . moveDone  ( )  ;
  assert ! playerDied   ( )   : "move possible => not killed"    ;
  }   else { if ( move   . playerDies  ( )  )  { assert ! playerWon   ( )   : "you can't win by dying"    ;
  getPlayer   ( )  . die  ( )   ;
  assert playerDied   ( )  ;
  }     }     assert invariant   ( )  ;
  }      public   boolean   playerDied ( )  { assert initialized   ( )  ;
  return ! getPlayer   ( )  . living  ( )   ;
  }      public   boolean   playerWon ( )  { assert initialized   ( )  ;
  return getPlayer   ( )  . getPointsEaten  ( )  >= totalPoints    ;
  }      public   boolean   gameOver ( )  { assert initialized   ( )  ;
  return playerWon   ( )  || playerDied   ( )   ;
  }      public   int   getPlayerLastDx ( )  { return getPlayer   ( )  . getLastDx  ( )  ;
  }      public   int   getPlayerLastDy ( )  { return getPlayer   ( )  . getLastDy  ( )  ;
  }      public   int   boardWidth ( )  { return getBoard   ( )  . getWidth  ( )  ;
  }      public   int   boardHeight ( )  { return getBoard   ( )  . getHeight  ( )  ;
  }      public   char   getGuestCode ( int   x   , int   y    )  { return getBoard   ( )  . guestCode  ( x   , y    )  ;
  }      }      